clear screen
----------------------------------------------------------

-- Drop user BFILE if it exists - Cleaning Up First
 
----------------------------------------------------------
 
connect / as sysdba

set serveroutput on
set echo on
set termout on
set feed on
 
drop user bfile cascade;

purge dba_recyclebin;
 
CREATE USER bfile PROFILE DEFAULT IDENTIFIED BY bfile;
 
grant xdbadmin, dba to BFILE;

-- GRANT JAVAUSERPRIV to BFILE;

EXECUTE dbms_java.grant_permission( 'BFILE', 'java.io.FilePermission','C:\UKOUG-2008\XML','read' );

pause
 
clear screen

----------------------------------------------------------

-- Create directory and show the content of an XML File
 
----------------------------------------------------------

connect bfile/bfile

set termout on
set feed on
set lines 40
set long 10000000
set serveroutput on
set echo on


drop directory XMLSTORE;

CREATE directory xmlstore AS 'C:\UKOUG-2008\XML';

SELECT extract((XMLTYPE(bfilename('XMLSTORE','test.xml'),NLS_CHARSET_ID('AL32UTF8'))),'*') AS "XML"
from   dual;
 
pause

clear screen

----------------------------------------------------------

-- Directory Listing - Tom Kyte
 
----------------------------------------------------------

create global temporary table DIR_LIST
 ( filename varchar2(255) )
 on commit delete rows
/
 

create or replace
  and compile java source named "DirList"
as
import java.io.*;
import java.sql.*;
 
public class DirList
{public static void getList(String directory)
                   throws SQLException
{   File path = new File( directory );
    String[] list = path.list();
    String element;
 
    for(int i = 0; i < list.length; i++)
    {   element = list[i];
        #sql { INSERT INTO DIR_LIST (FILENAME)
               VALUES (:element) };
}}}
/
 
create or replace procedure get_dir_list( p_directory in varchar2 )
  as language java
  name 'DirList.getList( java.lang.String )';
/
 
pause

clear screen

----------------------------------------------------------

-- The content of the global temporary table
 
----------------------------------------------------------

exec get_dir_list( 'C:\UKOUG-2008\XML' );
 

select * from dir_list;

-- "COMMIT" will clear / truncate the global temporary table...

pause 
 
clear screen

----------------------------------------------------------

-- Combined: Reading XML content from multiple XML files
 
----------------------------------------------------------
 
commit;

exec get_dir_list( 'C:\UKOUG-2008\XML' );
 
select * from dir_list where filename like '%.xml'; 

set lines 80
 
select extract((XMLTYPE(bfilename('XMLSTORE',dl.filename),NLS_CHARSET_ID('AL32UTF8'))),'*') AS "XML"
from   dir_list dl
where  dl.filename like '%.xml';
